/**
 * \file cf_queue.h
 *
 * \author myusgun <myusgun@gmail.com>
 *
 * \brief 큐
 *
 * \example queue.c
 */
#ifndef __CF_QUEUE_H__
#define __CF_QUEUE_H__

#include "cf_base.h"

/** 큐 컨텍스트 (Opaque) */
typedef void *	CF_Queue_Ctx;

#ifdef __cplusplus
extern "C" {
#endif

CF_EXPORT int
CF_Queue_CreateCtx		(CF_Queue_Ctx * ctx);

CF_EXPORT int
CF_Queue_DestroyCtx		(CF_Queue_Ctx ctx);

CF_EXPORT int
CF_Queue_Put			(CF_Queue_Ctx	ctx,
						 const void		* element);

CF_EXPORT int
CF_Queue_Get			(CF_Queue_Ctx	ctx,
						 void			** element);

CF_EXPORT int
CF_Queue_Front			(CF_Queue_Ctx	ctx,
						 void			** element);

CF_EXPORT int
CF_Queue_GetSize		(CF_Queue_Ctx ctx);

#ifdef __cplusplus
}
#endif

#endif // #ifndef __CF_QUEUE_H__
