/**
 * \file cf_thread.h
 *
 * \author myusgun <myusgun@gmail.com>
 *
 * \brief 멀티스레드 지원
 *
 * \example thread.c
 */
#ifndef __CF_THREAD_H__
#define __CF_THREAD_H__

#include "cf_base.h"

#include "cf_mutex.h"

/** 스레드 워커 함수 프로토타입 */
typedef int (* CF_Thread_Function) (void *);

/** 스레드 컨텍스트 */
typedef void *	CF_Thread_Ctx;

#ifdef __cplusplus
extern "C" {
#endif

CF_EXPORT int
CF_Thread_CreateCtx		(CF_Thread_Ctx		* ctx,
						 CF_Thread_Function	callback,
						 void				* arg);

CF_EXPORT int
CF_Thread_Start			(CF_Thread_Ctx ctx);

CF_EXPORT int
CF_Thread_DestroyCtx	(CF_Thread_Ctx ctx);

CF_EXPORT int
CF_Thread_Join			(CF_Thread_Ctx ctx);

#ifdef __cplusplus
}
#endif

#endif // #ifndef __CF_THREAD_H__
